### File I/O
---
### I/O

Computer Systems need to receive inputs, to calculate a desired output.

![[IO.png]]

---
### But how?
You already know of one way to get an Input:
```
Scanner sc = new Scaner(System.in);
```

---
### Is there any other way?


---

### So THATS what 'String[] args' means!

```
public static void main(String[] args){
	// main is a function.
	// Within main we can use the args parameter to access the cli arguments
	System.out.println("The amount of cli arguments is:" + args.length);
	for (int i = 0; i < args.length; i++){
		System.out.println("The " + i + ". Argument is: " + args[i]);
	}
}
```

---

### Excursion: Create runnable JAR File

Dear Future Greg,

I hope this slide finds you well. I am currently to lazy to create a detailed step by step guide to show your dear pupils how to create a runnable JAR File. Sadly you will have to show them this live, while sweating bricks that you JRE and JDK are compatible. Unfortunately for you, you will also have to create the step by step guide in addition to your troubles.

Cheers,
Asshole you from the past

---
### Excursion: Create runnable JAR File
1. Build your Project
2. Right click on Project folder > Export 
3.  Choose Runnable JAR File
4. Choose the proper launch configuration
5. Choose save destination
6. Finish!

You now have a runnable JAR File that you can call from the command line. 


---
### Now lets try that out:

```
java -jar <jarfile> <args>
```

This will allow our program to take in arguments from the command line and  use them within our Program. THIS is why we all the previous task were so heavy on String manipulation. YOU can manipulate Strings.

---

### Args vs. System.in

- System.in allows a user to *interactivly* change the behaviour of the program at runtime. It needs a user to input the data.
- Args allows a user or *another program* to change the behaviour of the program at the start of the program
---

### File Input

A popular argument to give to a program is a file. A file can store  an (almost) arbitrary amount and kind of data. This makes Files incredibly useful. While this might seem blatantly obvious at first, the implications of File I/O will become clearer once you understand that *EVERYTHING* on your (Unix*) computer is a file.

*Technically Unix Sockets are not files, but can be read from in most cases as if it were a file

---
### File Output

Files allow you to persist data. This means you can save arguments or calculations from your program. But even more importantly, Writing to a file, allows you to acces the results of your program through *another* program!

---

### So how do I do File IO?

Well lets RTFM and see what Prof. Klaus wants you to do!

[File IO as the Evil Mastermind intends](https://moodle.hs-mannheim.de/pluginfile.php/125982/mod_resource/content/9/pr1.teil2.pdf)

---

### Lets Try that:

```java
public static void main(String[] args){
	if (args.length == 0){
		System.out.println("No Arguments passed!");
		return;
	}
	File myFile = new File(args[0]);
	FileReader stream = new FileReader(myfile);
	BufferedReader input = new BufferedReader(stream);

	String line = input.readLine();
	while(line ! = null){
		System.out.println(line);
		line = line.readLine();
	}
}
```

---
---

